HDU 6092 Rikka with Subset

来源:互联网 发布:linux从入门到精通pdf 编辑:程序博客网 时间:2024/05/20 19:19

题目

Rikka with Subset

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 1193    Accepted Submission(s): 584


Problem Description
As we know, Rikka is poor at math. Yuta is worrying about this situation, so he gives Rikka some math tasks to practice. There is one of them:

Yuta has n positive A1An and their sum is m. Then for each subset S of A, Yuta calculates the sum of S

Now, Yuta has got 2n numbers between [0,m]. For each i[0,m], he counts the number of is he got as Bi.

Yuta shows Rikka the array Bi and he wants Rikka to restore A1An.

It is too difficult for Rikka. Can you help her?  
 

Input
The first line contains a number t(1t70), the number of the testcases. 

For each testcase, the first line contains two numbers n,m(1n50,1m104).

The second line contains m+1 numbers B0Bm(0Bi2n).
 

Output
For each testcase, print a single line with n numbers A1An.

It is guaranteed that there exists at least one solution. And if there are different solutions, print the lexicographic minimum one.
 

Sample Input
22 31 1 1 13 31 3 3 1
 

Sample Output
1 21 1 1
Hint
In the first sample, $A$ is $[1,2]$. $A$ has four subsets $[],[1],[2],[1,2]$ and the sums of each subset are $0,1,2,3$. So $B=[1,1,1,1]$

题目大意


   一个数组A他有n个元素,这n个元素一共形成了2的n次幂个A数组的子集,我们现在知道子集的和的个数,B[i]代表和为i的子集有多少个,现在让我们来确定数组A


解题思路


 官方题解说是背包那就是背包吧,我当时一点也没看出来,菜的毫无思路,赛后看题解,补完题才明白怎么去做的


这题的关键思想就是,他是一个一个的把元素拿出来,先从1开始往外拿,如果我们拿掉了一个1,那么现在 B[1]里面现在就少了一个变成了B'[1],那么原来的B[2]也变了,

B[2]要减去B'[1](因为拿出去的1是可以组合成2的,那具体组成了几个2呢,很显然1*B'[1]个2,所以减去B'[1]就可以了),变成B'[2],同理B'[3]。。。。。


#include<iostream>#include<cstdio>#include<cstring>#include<algorithm>using namespace std;#define LL long longLL n,m;LL B[10000+10];void work(){    memset(B,0,sizeof(B));    scanf("%lld%lld",&n,&m);    for(int i=0;i<=m;i++)    {        scanf("%lld",&B[i]);    }    while(n)    {        int flag=0;        for(int i=1;i<=m;i++)        {            if(B[i])            {                flag=i;                break;            }        }        if(n==1)            printf("%d\n",flag);        else        {            printf("%d ",flag);        }        for(int i=flag;i<=m;i++)            B[i]-=B[i-flag];        n--;    }}int main(){    int T;    scanf("%d",&T);    while(T--)    {        work();    }    return 0;}


原创粉丝点击